/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import java.time.LocalDateTime;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * Organization
 */

@JsonInclude(JsonInclude.Include.NON_NULL)
public class Organization {
  @JsonProperty("acronym")
  private String acronym = null;

  @JsonProperty("badges")
  private List<Badge> badges = null;

  @JsonProperty("created_at")
  private LocalDateTime createdAt = null;

  @JsonProperty("deleted")
  private LocalDateTime deleted = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("id")
  private String id = null;

  @JsonProperty("last_modified")
  private LocalDateTime lastModified = null;

  @JsonProperty("logo")
  private String logo = null;

  @JsonProperty("logo_thumbnail")
  private String logoThumbnail = null;

  @JsonProperty("members")
  private List<Object> members = null;

  @JsonProperty("metrics")
  private Object metrics = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("page")
  private String page = null;

  @JsonProperty("slug")
  private String slug = null;

  @JsonProperty("uri")
  private String uri = null;

  @JsonProperty("url")
  private String url = null;

  public Organization acronym(String acronym) {
    this.acronym = acronym;
    return this;
  }

   /**
   * The organization acronym
   * @return acronym
  **/
  @ApiModelProperty(value = "The organization acronym")
  public String getAcronym() {
    return acronym;
  }

  public void setAcronym(String acronym) {
    this.acronym = acronym;
  }

   /**
   * The organization badges
   * @return badges
  **/
  @ApiModelProperty(value = "The organization badges")
  public List<Badge> getBadges() {
    return badges;
  }

   /**
   * The organization creation date
   * @return createdAt
  **/
  @ApiModelProperty(value = "The organization creation date")
  public LocalDateTime getCreatedAt() {
    return createdAt;
  }

   /**
   * The organization deletion date if deleted
   * @return deleted
  **/
  @ApiModelProperty(value = "The organization deletion date if deleted")
  public LocalDateTime getDeleted() {
    return deleted;
  }

  public Organization description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The organization description in Markdown
   * @return description
  **/
  @ApiModelProperty(required = true, value = "The organization description in Markdown")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public Organization id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The organization identifier
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The organization identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

   /**
   * The organization last modification date
   * @return lastModified
  **/
  @ApiModelProperty(value = "The organization last modification date")
  public LocalDateTime getLastModified() {
    return lastModified;
  }

  public Organization logo(String logo) {
    this.logo = logo;
    return this;
  }

   /**
   * The organization logo URL
   * @return logo
  **/
  @ApiModelProperty(value = "The organization logo URL")
  public String getLogo() {
    return logo;
  }

  public void setLogo(String logo) {
    this.logo = logo;
  }

  public Organization logoThumbnail(String logoThumbnail) {
    this.logoThumbnail = logoThumbnail;
    return this;
  }

   /**
   * The organization logo thumbnail URL. This is the square (100x100) and cropped version.
   * @return logoThumbnail
  **/
  @ApiModelProperty(value = "The organization logo thumbnail URL. This is the square (100x100) and cropped version.")
  public String getLogoThumbnail() {
    return logoThumbnail;
  }

  public void setLogoThumbnail(String logoThumbnail) {
    this.logoThumbnail = logoThumbnail;
  }

  public Organization members(List<Object> members) {
    this.members = members;
    return this;
  }

  public Organization addMembersItem(Object membersItem) {
    if (this.members == null) {
      this.members = new ArrayList<Object>();
    }
    this.members.add(membersItem);
    return this;
  }

   /**
   * Get members
   * @return members
  **/
  @ApiModelProperty(value = "")
  public List<Object> getMembers() {
    return members;
  }

  public void setMembers(List<Object> members) {
    this.members = members;
  }

   /**
   * The organization metrics
   * @return metrics
  **/
  @ApiModelProperty(value = "The organization metrics")
  public Object getMetrics() {
    return metrics;
  }

  public Organization name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The organization name
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The organization name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

   /**
   * The organization page URL
   * @return page
  **/
  @ApiModelProperty(value = "The organization page URL")
  public String getPage() {
    return page;
  }

  public Organization slug(String slug) {
    this.slug = slug;
    return this;
  }

   /**
   * The organization string used as permalink
   * @return slug
  **/
  @ApiModelProperty(required = true, value = "The organization string used as permalink")
  public String getSlug() {
    return slug;
  }

  public void setSlug(String slug) {
    this.slug = slug;
  }

   /**
   * The organization API URI
   * @return uri
  **/
  @ApiModelProperty(value = "The organization API URI")
  public String getUri() {
    return uri;
  }

  public Organization url(String url) {
    this.url = url;
    return this;
  }

   /**
   * The organization website URL
   * @return url
  **/
  @ApiModelProperty(value = "The organization website URL")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Organization organization = (Organization) o;
    return Objects.equals(this.acronym, organization.acronym) &&
        Objects.equals(this.badges, organization.badges) &&
        Objects.equals(this.createdAt, organization.createdAt) &&
        Objects.equals(this.deleted, organization.deleted) &&
        Objects.equals(this.description, organization.description) &&
        Objects.equals(this.id, organization.id) &&
        Objects.equals(this.lastModified, organization.lastModified) &&
        Objects.equals(this.logo, organization.logo) &&
        Objects.equals(this.logoThumbnail, organization.logoThumbnail) &&
        Objects.equals(this.members, organization.members) &&
        Objects.equals(this.metrics, organization.metrics) &&
        Objects.equals(this.name, organization.name) &&
        Objects.equals(this.page, organization.page) &&
        Objects.equals(this.slug, organization.slug) &&
        Objects.equals(this.uri, organization.uri) &&
        Objects.equals(this.url, organization.url);
  }

  @Override
  public int hashCode() {
    return Objects.hash(acronym, badges, createdAt, deleted, description, id, lastModified, logo, logoThumbnail, members, metrics, name, page, slug, uri, url);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Organization {\n");

    sb.append("    acronym: ").append(toIndentedString(acronym)).append("\n");
    sb.append("    badges: ").append(toIndentedString(badges)).append("\n");
    sb.append("    createdAt: ").append(toIndentedString(createdAt)).append("\n");
    sb.append("    deleted: ").append(toIndentedString(deleted)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lastModified: ").append(toIndentedString(lastModified)).append("\n");
    sb.append("    logo: ").append(toIndentedString(logo)).append("\n");
    sb.append("    logoThumbnail: ").append(toIndentedString(logoThumbnail)).append("\n");
    sb.append("    members: ").append(toIndentedString(members)).append("\n");
    sb.append("    metrics: ").append(toIndentedString(metrics)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    slug: ").append(toIndentedString(slug)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

